---
layout: handbook-page-toc
title: Plan:Certify Engineering Team
---

## On this page
{:.no_toc .hidden-md .hidden-lg}

- TOC
{:toc .hidden-md .hidden-lg}

## Plan:Certify team

The Plan:Certify team works on both the backend and frontend parts of
GitLab's [Certify] categories in the [Plan stage].

For more details about the vision for this area of the product, see the
[Plan stage] page.

[Certify]: /handbook/product/categories/#certify-group
[Plan stage]: /direction/plan/

### Team members

<%= direct_team(manager_role: 'Fullstack Engineering Manager, Plan:Certify') %>

### Stable counterparts

<%= stable_counterparts(role_regexp: /[,&] (Plan(?!:)|Plan:Certify)/, direct_manager_role: 'Fullstack Engineering Manager, Plan:Certify') %>

### Hiring chart

Check out our [jobs page](/jobs/) for current openings.

### Team metrics dashboard

<%= partial("handbook/engineering/development/dev/plan/certify/metrics_dashboard") %>

### Application performance dashboard

<%= partial("handbook/engineering/development/dev/plan/certify/application_dashboard") %>

## OKRs

<%= partial("handbook/engineering/development/dev/plan/certify/engineering_okrs") %>

## Scalability Targets

| Type | Description | Estimated Timeline for Failure | Resolution Due Date | 12 Month Target | Issue | Status |
| ---- | ---          | ---                            | ---                | ---    | ---   | ---    |
| Redis Primary CPU | `EmailReceiverWorker` creates expensive `lpush` and `hset` operations on `redis-sidekiq` primary  | September 2021 | September 2021 | [1200 Service Desk][servicedesk] issues per day | [gitlab-com/gl-infra&469](https://gitlab.com/groups/gitlab-com/gl-infra/-/epics/469) | <span style='border-radius:0.2em; font-weight:bold; padding-left:1em; padding-right:1em; color:white; background-color:green;'>Resolved</span> |

[servicedesk]: https://gitlab.com/gitlab-com/www-gitlab-com/-/issues/11747#service-desk

Stage-wide scalability targets are available on the [Plan engineering page](/handbook/engineering/development/dev/plan/#engineering-scalability-targets).

## Work

See the [Plan stage page] and the [Plan:Project Management backend team page].

[Plan stage page]: /handbook/product/categories/#plan-stage
[Plan:Project Management backend team page]: /handbook/engineering/development/dev/plan-project-management-be/

### Capacity Planning

<%= partial("handbook/engineering/development/dev/plan/capacity_planning") %>

#### Weighing bugs

<%= partial("handbook/engineering/development/dev/plan/weighing_bugs") %>

### Collaborating across disciplines

#### Health Status

To help with visibility of whether or not an issue can be delivered in a milestone, the team uses health status to communicate quickly.
At the beginning of a milestone, all issues relating to the primary deliverable are assigned the "On track" status. Throughout the milestone, feature DRIs are responsible for updating issues statuses when necessary. If the health status is set to a status that is not "On Track", feature DRIs should leave a comment with additional details about why and if there's a way others on the team can help.
Using health status allows stakeholders, such as product and engineering managers, designers, and other engineers, to get a quick and easy overview of what is unlikely to make it into the current milestone.

#### Documentation

Documentation should accompany code for any [new or changed functionality] as per our
[definition of done]. This can become tricky when collaborating on a feature that is
behind a feature flag.

Since all feature flags start as disabled by default, we should aim to document the
feature as soon as it's safe for testing by users using the [feature flag template].
Don't wait until a feature is performant and stable to document it, instead do so once
it's secure and won't leave data in a corrupt, interim state.

Try to include docs with the first MR to introduce usable functionality. If this is
an API addition with no UI, document that and allow the FE engineers to update it as
work proceeds. As the feature flag rollout proceeds, the [documentation should be updated].

This avoids the rush to provide documentation that often accompanies the release cutoff.

[new or changed functionality]: https://about.gitlab.com/handbook/product/ux/technical-writing/workflow/#for-a-product-change
[definition of done]: https://docs.gitlab.com/ee/development/contributing/merge_request_workflow.html#definition-of-done
[feature flag template]: https://docs.gitlab.com/ee/development/documentation/feature_flags.html#features-disabled-by-default
[documentation should be updated]: https://docs.gitlab.com/ee/development/documentation/feature_flags.html#features-that-became-enabled-by-default


### Dashboards

<%= partial "handbook/engineering/metrics/partials/_cross_functional_dashboard.erb", locals: { filter_value: "Certify" } %>

More detail is available on our [metrics page].

[metrics page]: https://about.gitlab.com/handbook/engineering/metrics/dev/plan/certify/#mr-types-dashboard
[Work Type Classification]: https://about.gitlab.com/handbook/engineering/metrics/#work-type-classification

### Picking something to work on

The team [Build Board] always shows work in the current
release, with [workflow columns] relevant to implementation. Filtering it by
~backend shows issues for backend engineers to work on.

It's OK to not take the top item if you are not confident you can solve
it, but please post in [#s_plan] if that's the case, as this probably
means the issue should be better specified.

[workflow columns]: /handbook/product-development-flow/
[Build Board]: https://gitlab.com/groups/gitlab-org/-/boards/1569369?not[milestone_title]=Backlog
[#s_plan]: https://gitlab.slack.com/archives/s_plan

### Direction Items

Items that are customer-facing deliverables and high impact are labeled with ~"direction". We strive to have these items in production by two days before the release cut-off to give ample time for validation.

#### High Severity Issues

<%= partial("handbook/engineering/development/dev/plan/high_severity_items") %>

### Working on unscheduled issues

Everyone at GitLab has the freedom to manage their work as they see fit,
because [we measure results, not hours][results]. Part of this is the
opportunity to work on items that aren't scheduled as part of the
regular monthly release. This is mostly a reiteration of items elsewhere
in the handbook, and it is here to make those explicit:

1. We expect people to be [managers of one][efficiency], and we [use
   GitLab ourselves][collaboration]. If you see something that you think
   is important, you can [request for it to be scheduled], or you can
   [work on a proposal yourself][iteration], as long as you keep your
   other tasks in mind.
2. From time to time, there are events that GitLab team-members can participate
   in, like the [issue bash]. Anyone is welcome
   to participate in these.
3. If you feel like you want to have some specific time set aside, but
   aren't interested in the topics of an existing event, feel free to
   label issues with "For Scheduling" and copy your manager for visibility.

When you pick something to work on, please:

1. Follow the standard workflow and assign it to yourself.
2. Share it in [#s_plan] - if not even more widely (like in #development
   or #backend).

[collaboration]: /handbook/values/#collaboration
[results]: /handbook/values/#results
[efficiency]: /handbook/values/#efficiency
[iteration]: /handbook/values/#iteration

[request for it to be scheduled]: /handbook/engineering/workflow/#requesting-something-to-be-scheduled
[issue bash]: /community/issue-bash/

## Useful links

<%= partial("handbook/engineering/development/dev/plan/useful_links", locals: { board: { name: 'Plan:Product Planning', url: 'https://gitlab.com/groups/gitlab-org/-/boards/1569369?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=devops%3A%3Aplan&not[label_name][]=group%3A%3Aproject%20management' }}) %>
